IncludeFile "CPU_Flags.pb"
StandardFeaturesEDX.l
StandardFeaturesECX.l
ExtendedFeaturesEDX.l
ExtendedFeaturesECX.l
ViaFeatures.l
TransmetaFeatures.l
PowerManagementFeatures.l
Flags.l

Dim FlagValue.s(1)
FlagValue(0) = "NO"
FlagValue(1) = "YES"

;get the standard flags
! mov eax, 1
! CPUID
! mov [v_StandardFeaturesEDX], edx
! mov [v_StandardFeaturesECX], ecx

;get the extended flags
! mov     eax, $80000001
! CPUID
! mov [v_ExtendedFeaturesEDX],edx
! mov [v_ExtendedFeaturesECX],ecx

;get VIA flags
! mov eax, $C0000001
! CPUID
! mov [v_ViaFeatures], edx

;get Transmeta flags
! mov eax, $80860001
! cpuid
! mov [v_TransmetaFeatures], edx

;get power management flags
! mov eax, $80000007         ;get power management flags
! CPUID
! mov [v_PowerManagementFeatures], edx

If OpenWindow(0,0,0,760,550, "CPU Flags", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  	 Frame3DGadget(0, 10, 10, 740, 47, "Feature Flags")
 	 ButtonGadget(1,15,27,100,20,"Standard  1")
 	 ButtonGadget(2,115,27,100,20,"Standard  2")
 	 ButtonGadget(3,215,27,120,20,"Extended  1")
 	 ButtonGadget(4,335,27,120,20,"Extended  2")
 	 ButtonGadget(5,455,27,40,20,"VIA")
 	 ButtonGadget(6,495,27,100,20,"Transmeta")
 	 ButtonGadget(7,595,27,150,20,"Power Managenemt")
	 ListIconGadget(8,10,60,740,480,"bit",30,#PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect)
	 AddGadgetColumn(8,1,"Value",60)
	 AddGadgetColumn(8,2,"Name",80)
    AddGadgetColumn(8,3,"Description",400)
EndIf

Repeat
  Select WaitWindowEvent()
    Case #PB_Event_CloseWindow
      *Quit = #True
    Case #PB_Event_Gadget
		Select EventGadget()
    		Case 1
				EDXInfo(FlagCaption(),FlagDescription())
				Flags = StandardFeaturesEDX
			Case 2
				ECXInfo(FlagCaption(),FlagDescription())
				Flags = StandardFeaturesECX
			Case 3
				ExtEDXInfo(FlagCaption(),FlagDescription())
				Flags = ExtendedFeaturesEDX
			Case 4
				ExtECXInfo(FlagCaption(),FlagDescription())
				Flags = ExtendedFeaturesECX
			Case 5
				ViaInfo(FlagCaption(),FlagDescription())
				Flags = ViaFeatures
			Case 6
				TransInfo(FlagCaption(),FlagDescription())
				Flags = TransmetaFeatures
			Case 7
      		PowerManagementInfo(FlagCaption(),FlagDescription())
      		Flags = PowerManagementFeatures
		EndSelect
		ClearGadgetItems(8)
		For i=0 To 31
			AddGadgetItem(8,-1,Str(i) + Chr(10) + FlagValue(0 + ((Flags>>i) & 1)) + Chr(10) + FlagCaption(i) + Chr(10) + FlagDescription(i))
		Next		
  EndSelect
Until *Quit

End
; IDE Options = PureBasic 4.31 (Windows - x64)
; CursorPosition = 41
; FirstLine = 38
; EnableXP
; EnableAdmin
; DisableDebugger